<template>
  <div class="history-modal">
    <div class="history-table-wrapper">
      <ob-table v-if="!error"
        :columns="columns"
        :items="formDataArray"
        :functionalPanel="true"
        :is-functional-group="false"
        :is-functional-sort="false"
      />
      <div v-else style="padding: 10px;">{{ error }}</div>
    </div>
  </div>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable'
import TableLayoutMixin from '../../../mixins/table-layout-mixin'
import api from "@/api";
import moment from 'moment'
import riskIconMixin from '@/mixins/risk-icon'

export default {
  mixins: [TableLayoutMixin, riskIconMixin],
  props: {
    uuid: {
      type: String,
      default: ''
    }
  },
  components: { ObTable },
  data() {
    return {
      error: null,
      formDataArray: [],
      columns: [
        {
          title: 'Дата изменения',
          key: 'changed_at',
          sort: "datetime",
          html: ({ changed_at }) => this.getHtmlDatetime(changed_at)
        },
        {
          title: 'Оценка',
          key: 'risk_code',
          html: ({ risk_code }) => this.getHtmlRisk(risk_code),
        },
        {
          title: 'Автор',
          key: 'author_title',
        },
        {
          title: 'Комментарий',
          key: 'comment',
          html: ({ comment }) => this.getHtmlComment(comment),
        }
      ]
    }
  },
  methods: {
    getHtmlDatetime(datetime) {
      return datetime ? `
        <div class="field-datetime">
          <div>${moment(datetime).locale('ru').format('L')}</div>
          <div class="field-time">${moment(datetime).locale('ru').format('LT')}</div>
        </div>
      ` : ''
    },
    getHtmlRisk(risk_code) {
      return this.getRiskIcon(risk_code);
    },
    getHtmlComment(comment) {
      return comment || '<div class="empty">Нет комментария</div>'
    },

    async fetch() {
      try {
        const res = await api.resources.getHistory(this.uuid);
        this.formDataArray = res.data.hist_risk;
      } catch(e) {
        this.error = e.message;
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    }
  },
  created() {
    this.fetch();
  }
};
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .history-modal {
    .ob-form-controls-container {
      justify-content: flex-end;
    }
    &::v-deep {

      .empty {
        color: $resourcesPage-obModal-history_empty;
      }

      td {
        > div {
          display: flex;
          align-items: center;
        }
      }

      .field-datetime {
        @include font-mixin(14px, 20px, 400);

        .field-time {
          color: $color-grey-span;
        }
      }
    }
  }
  .history-table-wrapper {
    border: 1px solid $lavender;
    margin-bottom: 20px;
  }
</style>
